\documentclass[a4paper,12pt,oneside]{scrreprt}
\usepackage[latin1]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{ae,aecompl}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{ulem}
\usepackage{cancel}
\usepackage{float}
\usepackage{color}
% \usepackage{titlesec}
\usepackage{geometry}
\usepackage{listings}
\geometry{verbose,a4paper,tmargin=25mm,bmargin=25mm,lmargin=15mm,rmargin=25mm}
% \titlelabel{\thetitle.\quad}
\usepackage{tabularx}
\usepackage{booktabs}
\usepackage{pdfpages}
\usepackage{paralist}
\usepackage{textcomp}
\usepackage[official]{eurosym}

\usepackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
}

\renewcommand{\rmdefault}{phv}
\renewcommand{\sfdefault}{phv}

\begin{document}
    \begin{tabular*}{\textwidth}{c @{\extracolsep{\fill}} cc}
        \begin{large}
            \textbf{Prof. Lichter}
        \end{large} &

        \begin{minipage}[H]{3.5cm}
            \centering
            \begin{large}
                OOSC
            \end{large} \\
            \begin{large}
                WS 2019/2020
            \end{large}
        \end{minipage} &

        \begin{minipage}[H]{4cm}
            \includegraphics[keepaspectratio,width=\textwidth,angle=0]{logoswc.png}
        \end{minipage} \\
        Andreas Steffens & & \\
        Konrad F\"ogen & &  \\
        & \begin{huge}
              \textbf{Submission 5}
        \end{huge}&  \\
        & oosc@swc.rwth-aachen.de &  \\
        & & \\
        % Hier drunter mÃ¼ssen die Daten noch angepasst werden
        Issued: 02.12.2019 &
        Submission: 16.12.2019 &
        Discussion: 19.12.2019 \\
    \end{tabular*}
    \newline \newline \newline
    \begin{center}
        Submitted by

        \begin{tabular}{ll}
            Radu-Andrei Coanda, 344664. \\
            Clemens Frohnhofer, 333800\\
            Silas G\"unther, 382506  \\
            Christoph Kr\"amer, 318424  \\
        \end{tabular}
        \newline
        \\
        https://git.rwth-aachen.de/radu.coanda/19ws-oosc
    \end{center}

    \setcounter{chapter}{5} % Aktuelles Assigment
    \section{Framework}
    \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex1_domainModel.png}
	This is the domain model used for our SWCArchitect. \\
	The Furniture will be drawn and therefore should implement org.jhotdraw.draw.Figure from the framework. Moreover it has an image, which should be drawn and therefore should implement org.jhotdraw.draw.ImageHolderFigure. Since this interface already includes org.jhotdraw.draw.Figure, Furniture does not have to implement org.jhotdraw.draw.Figure explicitly. To keep it simple, Furniture could extend org.jhotdraw.draw.ImageFigure, which is the default implementation of org.jhotdraw.draw.ImageHolderFigure.\\
	The Group Class should implement org.jhotdraw.draw.CompositeFigure since this is the Interface which can handle multiple child figures.\\
	The Element Class should implement org.jhotdraw.draw.Figure, since the Element class should also be drawn. \\
	Since Flat and Catalogue both hold references to classes that implement org.jhotdraw.draw.Figure, both of them should have a reference to an object that implements from org.jhotdraw.draw.Drawing, so that the figures can be added to the Drawing. Since both classes should draw on one canvas, they should not hold different drawings, but the same. \\
	For the other classes inside the domain model there exists no interface which should be implemented.\\
	
	\includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex1_useCase.png}
	For the use cases there are not many code components that can be used. For the Modifications to Layout (Add Element to Layout, Remove Element from Layout, Import Background Image) an Abstract Action like org.jhotdraw.draw.action.AbstractDrawingEditorAction or org.jhotdraw.draw.action.AbstractDrawingViewAction can be extended. \\
	For Export Layout, Export Layout to File and Publish Layout to Web Service the org.jhotdraw.draw.io.OutputFormat Interface can be used to implement the functionaity.\\
	
	Since JHotDraw has many classes and interfaces which can be implemented and extended for reuse and customization, JHotDraw is an open framework, a so called white-box framework.\\
	
	Although JHotDraw is powerfull and has a lot of functionality needed for the SWCArchitect-Application, it is also not good documented. Since JHotDraw is an open framework the programmer has to know a lot about the framework and therefore a good documentation is important. Therefore it is okay to use JHotDraw, when there is time for getting to know the Framework and maybe to write an own documentation. If this is not the case, I would switch to a better documented framework. 
  	
    \section{Components}
    We're analysing the following suggested component list, 
    debating whether or not the suggested components adher 
    to the important rules and properties of component design:

    \paragraph{SketchImporter:} imports the existing sketches and place as a background
    image
    \begin{itemize}
        \item \textbf{Review:} We believe that this component upholds all properties of good
        component design. The purpose is well defined (import image file as background 
        image), it is loosely coupled from other components with which it interacts (through
        the interface it implements)

        \item \textbf{Interface:} The interface it implements is the one of the ImageHolderFigure.
        \item \textbf{Interactions with other components:} The interaction happens through the ImageTool 
        component.
        \item \textbf{Included classes or entities:} We are also extending the class AbstractAttributedDecoratedFigure.
        \item \textbf{Integration with JHotDraw:} Finally we integrate this into the application
        through a button interaction, which calls the ImageTool constructing finally the BackgroundImageFigure.
    \end{itemize}

    \paragraph{FlatModeler:} defining flat, place flat elements (walls, doors), place furniture
    elements (tables, chairs)

    \begin{itemize}
        \item \textbf{Review:} We believe that, here, we are encountering multiple smaller components,
        such as the flat elements construction, but also the different furniture construction. Each small
        component is well defined and independent. The interaction between client and component is restricted
        to the interface Figure and it is easily to configure the component.

        \item \textbf{Interface:} The interface it implements is the one of the Figure.
        \item \textbf{Interactions with other components:} The interaction happens through the CreationTool 
        component.
        \item \textbf{Included classes or entities:} We are also extending the class AbstractAttributedFigure.
        \item \textbf{Integration with JHotDraw:} Finally we integrate this into the application
        through a button interaction, which calls the CreationTool constructing finally the respective figure.
    \end{itemize}

    \paragraph{ImageExporter:} export drawings as jpg, pdf, png ...
    \begin{itemize}
        \item \textbf{Review:} We believe that, the ImageExporter is a well defined component that upholds
        the principles and rules fo good component design. It is well defined (i.e. export flat image of the view), 
        the separation between implementation and interface is kept through URIChooser.

        \item \textbf{Interface:} The interface it implements is the one of the URIChooser.
        \item \textbf{Interactions with other components:} Everything is ran in ExportFileAction.
        \item \textbf{Included classes or entities:} We are usign a ExtensionFileFilter to filter for PNG exports.
        \item \textbf{Integration with JHotDraw:} Explained above.
    \end{itemize}

    \paragraph{WebPublisher:} exports a drawing to a remote publishing service
    \begin{itemize}
        \item \textbf{Review:} We believe that, the WebPublisher is a well defined component that upholds
        the principles and rules fo good component design. It is well defined (i.e. export a flat image to a web publishing service).
        
        \item \textbf{Interface:} The interface it implements is the one of the URIChooser.
        \item \textbf{Interactions with other components:} Everything is ran in ExportFileAction.
        \item \textbf{Included classes or entities:} We are usign a ExtensionFileFilter to filter for PNG exports.
        \item \textbf{Integration with JHotDraw:} An interface for the web service API might not be yet implemented in JHotDraw, but it can be imagined that one would need one. Afterwards
        we would just extend the AbstractViewAction similarly to ExportFileAction to use the web service interface.
    \end{itemize}

    \paragraph{FurnitureFactory:} generates furniture elements
    \begin{itemize}
        \item \textbf{Review:} We believe that, the FurnitureFactory is a well defined component that upholds
        the principles and rules fo good component design. 
        \item \textbf{Interface:} It uses a new Furniture interface, that all concrete implementations will implement.
        \item \textbf{Interactions with other components:} 
        \item \textbf{Included classes or entities:} 
        \item \textbf{Integration with JHotDraw:} 
    \end{itemize}

    \paragraph{ChairTableGrouping:} takes two or more tables and chairs and merges them to
    one figure

    \begin{itemize}
        \item \textbf{Review:} We believe that this component does not uphold to the rules of good component design,
        as we think that the \textit{Separation of Interface and Implementation} is broken. The compont should be more general 
        and work on the Figure interface. Therefore a FigureGrouping would be more appropriate.
    \end{itemize}

    \paragraph{ConstraintValidation:} after each movement of an element this component
    checks if certain constraints are violated

    \begin{itemize}
        \item \textbf{Review:} We believe that this component upholds all properties of good
        component design. It has a well defined purpose (i.e. to validate constraints), it is
        loosely coupled through interfaces and configurable by changing the constraints.

        \item \textbf{Interface:} The interface it implements is the one of the FigureListener.
        \item \textbf{Interactions with other components:} This happens by registering the lsiteners to the figures, 
        and fireing when a move of the figure happens.
        \item \textbf{Included classes or entities:} We are also extending the class AbstractFigure.
        \item \textbf{Integration with JHotDraw:} Finally we integrate this into the application
        through the registration of a new FigureEvent and FigureListener, that fire and respectively
        listene for the event and check the new configuration.
    \end{itemize}


    
    \section{Implementation}
    Git-Commit-Id: 2cd03df0443c5254887c6017787b47fec2be1ff0
    \\
    \newline
    SketchImporter was implemented using the ImageTool Component and by creating a new Subclass of the ImageHolderFigure, so that the placement of the background image will always be on the top left corner. The ImageTool handles all the necessary Dialogs and User Interaction.
    \\
    \newline
    Furniture elements were implemented as subclasses of AbstractAttributedFigure. There it was possible to modifiy the draw method and let the furniture shape be drawn. Via the CreationTool each furniture element was added to the toolbar. The CretionTool again handled all the user interaction, the placement and resizing, of the furniture element.
    \\
    \newline
    The export functionality was enabled by introducing and export chooser and an ExtnsionFileFilter to it, to filter only for pngs.
    
    
    
    \section{Use the SWCArchitect}
    \includegraphics[keepaspectratio,width=\textwidth,angle=0]{room.jpg}
    \includegraphics[keepaspectratio,width=\textwidth,angle=0]{floorplan.png}



\end{document}
